#if !defined(AFX_GVNGPLUGIN_H__A8B48206_102E_11D3_9705_000000000000__INCLUDED_)
#define AFX_GVNGPLUGIN_H__A8B48206_102E_11D3_9705_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GVNGPlugin.h : header file
//
// ------------ DLL event's ------------------
#define DLLF_ON_LOAD						0x00000001
#define DLLF_ON_INITIALIZE				0x00000002
#define DLLF_ON_CLOSE					0x00000004
#define DLLF_ON_DATACHANGED			0x00000008
#define DLLF_ON_GAMESLISTMODIFIED	0x00000010
#define DLLF_ON_TURNCHANGED			0x00000020
#define DLLF_ON_REPORTLOADED			0x00000040
#define DLLF_ON_USERCOMMAND			0x00000080
#define DLLF_ON_ABOUT					0x00000100
#define DLLF_ON_PLANETCHANGED			0x00000200
#define DLLF_ON_TABLEPROCESSOR		0x00000400
#define DLLF_ON_TABLEFILTER			0x00000800
#define DLLF_CREATE_CONFIG				0x00001000
#define DLLF_ON_OK						0x00002000

// ------------ Screen ID's ------------------
#define SID_INCOMING						51446
#define SID_BOMBING						51452
#define SID_RACES							51467
#define SID_PLANETS						51477
#define SID_GROUPS						51481
#define SID_BATTLES						51491
#define SID_SHIPCALC						51498
#define SID_PLANETINFO					51507
#define SID_SCIENCES						51557
#define SID_SHIPTYPES					51575
#define SID_BROADCAST					51682
#define SID_NOTES							51689
#define SID_MAIL							51691
#define SID_CALCULATOR					51734
#define SID_BATTLESIMULATOR			51751
#define SID_FLEETS						51895
// -------------------------------------------
#define GET_DATA(x,y) {if (!map.Lookup(x,y)) return;}
#define PUT_DATA(x,y) {map.SetAt(x,y);}

/////////////////////////////////////////////////////////////////////////////
// GVNGPlugin thread

class GVNGPlugin : public CWinApp
{
public:
	GVNGPlugin();

// Attributes

// Operations
public:

	// External GVNG messages
	///////////////////////////////////////////////
	void virtual OnLoad(){};
	void virtual OnInitialize(CMapStringToString&);
	void virtual OnClose(){};
	void virtual OnDataChanged(CMapStringToString&){};
	void virtual OnGamesListModified(CMapStringToString&){};
	void virtual OnTurnChanged(CMapStringToString&){};
	void virtual OnReportLoaded(CMapStringToString&){};
	void virtual OnUserCommand(CMapStringToString&){};
	void virtual OnPlanetChanged(CMapStringToString&){};
	void virtual OnAbout(CMapStringToString&){};
	void virtual OnTableProcessor(CMapStringToString&,CStringArray&){};
	BOOL virtual OnTableFilter(CMapStringToString&,CStringArray&){return TRUE;};
	void virtual CreateConfig(CMapStringToString&){};
	void virtual OnOK(CMapStringToString&){};
	///////////////////////////////////////////////

	DWORD* m_pEventMask;

// Dates
	HWND m_hMainFrame;
	FARPROC m_pDataManager;
	CFrameWnd* pMainFrame;

	void RegWrite(CString,CString);
	void RegRead(CString,CString&);
	void DataAccess(CString,LONG,CString,CStringList&,CMapStringToString&); 

public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(GVNGPlugin)
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(GVNGPlugin)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GVNGPLUGIN_H__A8B48206_102E_11D3_9705_000000000000__INCLUDED_)
